﻿using System.Windows;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.pasteButton.Command = ApplicationCommands.Paste;
            this.pasteButton.Content = ApplicationCommands.Paste.Text;

            CommandBinding commandBinding = new CommandBinding
            (
                ApplicationCommands.Paste,
                pasteButton_Executed,
                pasteButton_CanExecute
            );

            CommandBindings.Add(commandBinding);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Paste 버튼 실행시 처리하기 - pasteButton_Executed(sender, e)

        /// <summary>
        /// Paste 버튼 실행시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void pasteButton_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            this.textBlock.Text = Clipboard.GetText();
        }

        #endregion
        #region Paste 버튼 실행 가능 여부 처리하기 - pasteButton_CanExecute(sender, e)

        /// <summary>
        /// Paste 버튼 실행 가능 여부 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void pasteButton_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = Clipboard.ContainsText();
        }

        #endregion
   }
}